//
//  DefaultCRT.java
//  Red Queen Simulator
//
//  Created by John Damuth on Thu Jan 27 2005.
//  Copyright (c) 2005 Pantherion Corporation. All rights reserved.
//  Version 1.5

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;

public class DefaultCRT extends JPanel {

	Dimension	size,child_size;
	Color drawColor = new java.awt.Color(175, 210, 40);
	boolean	shutting_off = false;
	SlopesCRT slcrt;
	ShutDownCRT shutcrt;
	PointsCRT	pcrt;
	SeudsCRT	seudcrt;
	SdevCRT		sdcrt;
	JToggleButton	videoSwitch;
	JToggleButton	analysisSwitch;

	public DefaultCRT(Dimension sz, JToggleButton VMS, JToggleButton AMS){
	
		size = sz;
		videoSwitch = VMS;
		analysisSwitch = AMS;
		child_size = new Dimension(size.width-10, size.height-10);
	
		this.setBorder(new SoftBevelBorder(SoftBevelBorder.LOWERED));
		setBackground(new java.awt.Color(30, 45, 30));
		setSize(size);
		slcrt = new SlopesCRT(child_size);
		slcrt.setVisible(false);
		pcrt = new PointsCRT(child_size);
		pcrt.setVisible(false);
		seudcrt = new SeudsCRT(child_size);
		seudcrt.setVisible(false);
		sdcrt = new SdevCRT(child_size);
		sdcrt.setVisible(false);		
		shutcrt = new ShutDownCRT(child_size);
		shutcrt.setVisible(false);		
		this.add(slcrt);
		this.add(pcrt);
		this.add(seudcrt);
		this.add(sdcrt);
		this.add(shutcrt);
		
		
		}
		
	
	
	public void clearSlopeView(){
			if(slcrt.isVisible()){
				slcrt.ClearDisplay();
				}
			else if (sdcrt.isVisible()){
				sdcrt.ClearDisplay();
				}
			}
	
	
	public void turn_on_CRT () {
	
			if(shutcrt.isVisible()) shutcrt.setVisible(false);
			if(slcrt.isVisible()) slcrt.setVisible(false);
			turnOnThread to = new turnOnThread(this);
			to.start();

	
		}
		
	public void turn_off_CRT () {
			if(shutcrt.isVisible()) shutcrt.setVisible(false);
			if(slcrt.isVisible()) slcrt.setVisible(false);	
			turnOffThread tof = new turnOffThread(this);
			tof.start();

	
		}	
		
	public void setTimesteps(int ts){
		if(slcrt.isVisible()) slcrt.setTimesteps(ts);
		if(sdcrt.isVisible()) sdcrt.setTimesteps(ts);
		}
			
		
	public void toggle_video(int mode, boolean seud){
		if(mode==0){
			if(shutcrt.isVisible()) shutcrt.setVisible(false);
			if(pcrt.isVisible()) pcrt.setVisible(false);
			if(seudcrt.isVisible()) seudcrt.setVisible(false);
			if(slcrt.isVisible()) slcrt.setVisible(false);
			if(sdcrt.isVisible()) sdcrt.setVisible(false);	
			if(seud)
				sdcrt.setVisible(true);
			else
				slcrt.setVisible(true);
			}
		else if(mode==1){
			if(shutcrt.isVisible()) shutcrt.setVisible(false);
			if(slcrt.isVisible()) slcrt.setVisible(false);
			if(pcrt.isVisible()) pcrt.setVisible(false);
			if(seudcrt.isVisible()) seudcrt.setVisible(false);
			if(sdcrt.isVisible()) sdcrt.setVisible(false);
			if(seud)
				seudcrt.setVisible(true);
			else
				pcrt.setVisible(true);
			}
		}	
		
		
		
		
	public class turnOnThread extends Thread  { 
	
		DefaultCRT target;
		
		public turnOnThread(DefaultCRT tgt){		
			target = tgt;
			}
		
		public void run(){
			videoSwitch.setEnabled(false);
			analysisSwitch.setEnabled(false);
			try{
				sleep(2000);
				for(int i = 0;i<80;i++){
					target.setBackground(new java.awt.Color(30, 45+i, 30));
					sleep(50);
					}
				slcrt.setVisible(true);
				sleep(1000);
				}
			catch(InterruptedException e){
				e.printStackTrace();
				}
			videoSwitch.setEnabled(true);	
			analysisSwitch.setEnabled(true);
			}
		}		

	public class turnOffThread extends Thread  { 
	
		DefaultCRT target;
		
		public turnOffThread(DefaultCRT tgt){		
			target = tgt;
			}
		
		public void run(){
			videoSwitch.setEnabled(false);
			if(slcrt.isVisible()) slcrt.setVisible(false);
			if(pcrt.isVisible()) pcrt.setVisible(false);
			if(seudcrt.isVisible()) seudcrt.setVisible(false);
			if(sdcrt.isVisible()) sdcrt.setVisible(false);
			try{
				shutting_off = true;
				sleep(100);
				target.setBackground(new java.awt.Color(30, 45, 30));
				shutcrt.setVisible(true);
				shutcrt.repaint();
				for(int i = 0;i<150;i=i+2){
					shutcrt.setLineWidth(2+i, 298-i);
					if(i<=65) shutcrt.changeColor(180+i,190+i,90+i+i);
					shutcrt.repaint();
					sleep(20);
					}
				for(int i = 0;i<213;i++){
					shutcrt.changeColor(245-i,255-i,245-i);
					shutcrt.repaint();
					sleep(50);
					}
				}
			catch(InterruptedException e){
				e.printStackTrace();
				}
			}
		}		

}