//
//  PointsCRT.java
//  Red Queen Simulator
//
//  Created by John Damuth on Thu Jan 27 2005.
//  Copyright (c) 2005 Pantherion Corporation. All rights reserved.
//  Version 1.5

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;
import java.text.DecimalFormat;


public class PointsCRT extends Canvas {

	Dimension	size;
	Color 		drawColor = new java.awt.Color(175, 210, 40);

	public PointsCRT(Dimension sz){
	
		size = sz;
		setBackground(new java.awt.Color(30, 125, 30));
		setSize(size);
		setFont(new java.awt.Font("Helvetica", 0, 10));
		setLocation(new java.awt.Point(5, 8));
		}

	public void draw_graph(int timestep, double slope, double yint, Vector splist, double min_den){		
		Graphics g = this.getGraphics();
		g.setColor(drawColor);
		g.translate(40,20);
		
		g.clearRect(1,-20,220,220);
		
		for(int i=0;i<splist.size();i++){
			RQSpecies sp = (RQSpecies)splist.elementAt(i);
			if(!sp.getExtinct()){
				int x = (int)Math.round(log10(sp.getMass()) * 32.0 );
				int y = 150 - (int)Math.round((log10(sp.getDensity()) - log10(min_den)) * 32);
				if (y < 200){
					if(sp.IsNew()) g.setColor(Color.red); //To show new species
					else g.setColor(drawColor);
					g.fillOval(x,y,2,2);
					}
				}
			}
		
		int yu1 = 150 - (int)Math.round( ((0.5 * slope) + yint - log10(min_den)) * 32);
		int yu2 = 150 - (int)Math.round( ((6.0 * slope) + yint - log10(min_den)) * 32);
		int xu1 = (int)Math.round(0.5 * 32);
		int xu2 = (int)Math.round(6.0 * 32);

		g.setColor(drawColor);
		g.drawLine(xu1,yu1,xu2,yu2);
		DecimalFormat df = new DecimalFormat("###.000");
		g.drawString("Slope: " + df.format(slope),40,200);	
		
		}
		
	public void testDraw(){  // Just for testing purposes
		Graphics g = this.getGraphics();
		g.setColor(drawColor);
		
		g.drawLine(40,165,45,160);
		g.drawLine(45,160,50,160);
		g.drawLine(50,160,55,150);
		g.drawLine(55,150,60,142);
		g.drawLine(60,142,65,151);
		g.drawLine(65,151,70,148);
		g.drawLine(70,148,75,133);
		g.drawLine(75,133,80,138);
		g.drawLine(80,138,85,135);
		g.drawLine(85,135,90,144);
		g.drawLine(90,144,95,139);
		g.drawLine(95,139,100,131);
		}

	public void paint(Graphics g) {	
		
		
		
		g.setColor(drawColor);
		
		g.drawLine(40,20,40,220);
		g.drawLine(40,220,270,220);

		g.drawString("0",40,235);
		g.drawString("7",264,235);
		g.drawString("Log Body Mass", 115,240);	
	
	
		
		} 

	public double log10(double x) {
  		return Math.log(x)/Math.log(10.0);  
		}
		
}