//
//  SlopesCRT.java
//  Red Queen Simulator
//
//  Created by John Damuth on Thu Jan 27 2005.
//  Copyright (c) 2005 Pantherion Corporation. All rights reserved.
//  Version 1.5

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;
import java.text.DecimalFormat;

public class SlopesCRT extends Canvas {

	Dimension	size;
	Color 		drawColor = new java.awt.Color(175, 210, 40);
	int			timesteps;
	static int lastx;
	static int lasty;
	
	public SlopesCRT(Dimension sz){
	
		size = sz;
		setBackground(new java.awt.Color(30, 125, 30));
		setSize(size);
		setFont(new java.awt.Font("Helvetica", 0, 10));
		setLocation(new java.awt.Point(5, 8));
		}
		
	public void setTimesteps(int ts){
		timesteps = ts;
		if(this.isVisible()) repaint();
		}
		
	public void ClearDisplay(){
		Graphics g = this.getGraphics();
		
		g.clearRect(0,0,size.width,size.height);	
		paint(g);
		}
		
	public void draw_slope(int timestep, double slope){	
		Graphics g = this.getGraphics();
		g.setColor(drawColor);
		g.translate(40,20);
		
		int x = (int)(timestep * 200/timesteps);
		int y = (int)((200/3) * ((-1 * slope) + 0.75));
		
		if(timestep >= 1){
			if (timestep == 1){
				lastx = x;
				lasty = y;
				}
			g.drawLine(lastx,lasty,x,y);
			}
			
		lastx = x;
		lasty = y;
		
		if(timestep==timesteps){
			lastx = 0;
			lasty = 0;
			}
		
		}
		
	public void testDraw(){  // Just for testing purposes
/*		Graphics g = this.getGraphics();
		g.setColor(drawColor);
		
		g.drawLine(40,165,45,160);
		g.drawLine(45,160,50,160);
		g.drawLine(50,160,55,150);
		g.drawLine(55,150,60,142);
		g.drawLine(60,142,65,151);
		g.drawLine(65,151,70,148);
		g.drawLine(70,148,75,133);
		g.drawLine(75,133,80,138);
		g.drawLine(80,138,85,135);
		g.drawLine(85,135,90,144);
		g.drawLine(90,144,95,139);
		g.drawLine(95,139,100,131); */
		}


	public void repaint(){}

	public void paint(Graphics g) {	
		
		
		
		g.setColor(drawColor);
		
		g.drawLine(40,20,40,220);
		g.drawLine(40,220,270,220);
		g.drawLine(40,120,270,120);
		
		g.drawString("Timesteps", 115,240);
		g.drawString("Slope", 5,90);
		g.drawString("+0.75", 5,25);
		g.drawString("-2.25", 5,225);
		
		g.drawString("-0.75",10,125);
		g.drawString("0",40,235);
		g.drawString(""+timesteps,260,235);	
	
	
		
		} 


		
}